Bug 1513293 - Review Request: rejson - JSON data type for Redis
Summary: Review Request: rejson - JSON data type for Redis
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
(Show other bugs)
Version: rawhide
Hardware: All Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: FE-Legal
TreeView+ depends on / blocked
 
Reported: 2017-11-15 05:59 UTC by Nathan Scott
Modified: 2018-10-01 13:03 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-11-22 20:07:04 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Nathan Scott 2017-11-15 05:59:17 UTC
Spec URL: https://nathans.fedorapeople.org/rejson/rejson.spec
SRPM URL: https://nathans.fedorapeople.org/rejson/rejson-0.99.1-1.fc26.src.rpm

Description:
ReJSON is a Redis module that implements the JSON Data
Interchange Standard as a native data type.  It allows
storing, updating and fetching JSON values from Redis.

Fedora Account System Username: nathans

Comment 1 Robert-André Mauchin 2017-11-15 17:50:09 UTC
Hello,

 - You *must* install the LICENSE file with the %license macro:

%files
%license LICENSE

 - You should own /usr/lib64/redis and /usr/lib64/redis/modules or Requires a package that own these directories:

[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib64/redis, /usr/lib64/redis/modules
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib64/redis/modules,
     /usr/lib64/redis

   (Personally I think the Redis package sould be updated to own these directories)



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "AGPL (v3)", "Unknown or generated", "MIT/X11 (BSD like)", "BSD
     (3 clause)", "AGPL (v3 or later)", "ISC". 245 files have unknown
     license. Detailed output of licensecheck in
     /home/bob/packaging/review/rejson/review-rejson/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib64/redis, /usr/lib64/redis/modules
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib64/redis/modules,
     /usr/lib64/redis
[x]: Package does not own files or directories owned by other packages.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 634880 bytes in 40 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rejson-
     debuginfo , rejson-debugsource
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rejson-0.99.1-1.fc28.x86_64.rpm
          rejson-debuginfo-0.99.1-1.fc28.x86_64.rpm
          rejson-debugsource-0.99.1-1.fc28.x86_64.rpm
          rejson-0.99.1-1.fc28.src.rpm
rejson-debugsource.x86_64: W: no-documentation
rejson.src: E: specfile-error warning: line 12: Possible unexpanded macro in: Requires:	redis(modules_abi)(x86-64) = %{redis_modules_abi}
4 packages and 0 specfiles checked; 1 errors, 1 warnings.

Comment 2 Nathan Scott 2017-11-17 06:31:21 UTC
(In reply to Robert-André Mauchin from comment #1)
> Hello,
> 

Hi, thanks for reviewing!

>  - You *must* install the LICENSE file with the %license macro:
> 
> %files
> %license LICENSE
> 

Fixed.

>  - You should own /usr/lib64/redis and /usr/lib64/redis/modules or Requires
> a package that own these directories:
> 
> [!]: Package requires other packages for directories it uses.
>      Note: No known owner of /usr/lib64/redis, /usr/lib64/redis/modules
> [!]: Package must own all directories that it creates.
>      Note: Directories without known owners: /usr/lib64/redis/modules,
>      /usr/lib64/redis
> 
>    (Personally I think the Redis package sould be updated to own these
> directories)
> 

Fixed up as per BZ 1513291.

Updated packages at:
Spec URL: https://nathans.fedorapeople.org/rejson/rejson.spec
SRPM URL: https://nathans.fedorapeople.org/rejson/rejson-0.99.1-2.fc26.src.rpm

cheers.

Comment 3 Robert-André Mauchin 2017-11-17 13:21:30 UTC
All good, package accepted.

Comment 4 Gwyn Ciesla 2017-11-21 13:10:33 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/rejson

Comment 5 Armijn Hemel 2018-08-21 09:05:15 UTC
A month ago the license was changed to Apache 2 with "Commons Clause". This makes it incompatible with any open source license out there:

https://github.com/RedisLabsModules/rejson/blob/master/LICENSE

https://redislabs.com/community/commons-clause/

I would strongly recommend reconsidering the inclusion of this package.

Comment 6 Richard Fontana 2018-08-21 14:42:08 UTC
Blocking on Fedora Legal.

Comment 7 Richard Fontana 2018-08-21 16:14:55 UTC
Not sure if FE-Legal is appropriate in this case since this is closed but alerting Tom Callaway who will know what to do.

Comment 8 Nathan Scott 2018-08-22 06:06:58 UTC
Thanks for the heads-up Armijn.  I expect that we can continue to ship the current versions of this (and the similarly-affected rebloom) Redis module in Fedora, since these earlier releases are not affected by the license change.

However, this is far from ideal and this is a real shame - it seems like an unfortunate direction for RedisLabs to have taken, from a Fedora POV.

Comment 9 Tom "spot" Callaway 2018-10-01 13:03:38 UTC
Nathan, as you note in Comment 8, we are okay with versions 1.0.2 and older, but you should not move to any newer versions unless the licensing issue is resolved.


Note You need to log in before you can comment on or make changes to this bug.